VERSION 5.00
Begin VB.Form dlgMain 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "ActiveVB TreeClass Beispiel"
   ClientHeight    =   2955
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3915
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2955
   ScaleWidth      =   3915
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox txtOutput 
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2835
      Left            =   60
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   60
      Width           =   3795
   End
End
Attribute VB_Name = "dlgMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Family  As CTreeNode

Private Sub Form_Load()
    Dim Generation As CTreeNode
    
    ' Erstellen des Trees
    Set Family = New CTreeNode
    
    ' zwei Rooteintrge
    Call Family.Add("C:", "Programme")
    Call Family.Add("D:", "Daten")
    
    Set Generation = Family.Item("C:")  ' korrekt
    
    ' Untereintrge unter C:
    Call Generation.Add("Programme", "Programme")
    Call Generation.Add("Windows", "Windows")
    Call Generation("Windows").Add("System32", "System32")
    
    Set Generation = Family![D:]    ' inkorrekter, aber
                                    ' interessanter Weg
    
    ' Untereintrge unter D:
    Call Generation.Add("Archiv", "Archiv")
    Call Generation.Add("Eigene Dateien", "Eigene Dateien")
    
    ' 3 alternative Wege, einen Untereintrag unter
    ' D:\Eigene Dateien hinzuzufgen
    Call Generation.Item("Eigene Dateien").Add("Eigene Bilder", "Eigene Bilder")
    Call Family.Item("D:\Eigene Dateien\Eigene Bilder").Add("Strandfotos", "Strandfotos")
    Family![D:]![Eigene Dateien].Add "Eigene Musik", "Eigene Musik"
    
    ' Baum anzeigen
    Call ShowNodes(Family, 0)
End Sub

Private Sub ShowNodes(ByRef Node As CTreeNode, ByVal Level As Long)
    If Node Is Nothing Then _
        Exit Sub
    
    If Node.Key <> Node.Value Then
        txtOutput.Text = txtOutput.Text & _
                            String$(Level * 2, "") & _
                            Node.Value & " (" & Node.Key & ")" & _
                            vbNewLine
    Else
        txtOutput.Text = txtOutput.Text & _
                            String$(Level * 2, "") & _
                            Node.Value & vbNewLine
    End If
    
    If Node.Nodes Is Nothing Then _
        Exit Sub
    
    Call ShowNodes(Node.Nodes, Level + 1)
    Call ShowNodes(Node.Nodes.Next_, Level + 1)
End Sub
